/* ToneMatrix - main.h
 * Copyright (c) 2011 Tanner Babcock */
#ifndef MAIN_H
#define MAIN_H

#include <oslib/oslib.h>
#include <pspmodulemgr.h>

#define VERSION "0.5"
#define bool char
#define tmAbort(x) \
	tmDebug(10, x, "Getting TFO..."); \
	sceKernelExitGame()
#define OFFC RGBA(30,30,30,255)		// when node is off
#define ONC RGBA(199,199,199,255)	// when node is on
#define HOFF RGBA(50,50,50,255)		// when node is lit up and off
#define HON RGBA(220,220,220,255)	// when node is lit up and on
#define x1form ((x*30)-29)
#define y1form ((15+(y*30))-29)
#define x2form ((x*30)-1)
#define y2form ((15+(y*30))-1)

enum { FALSE, TRUE };
enum { OFF, ON, CURSOFF, CURSON };
enum { STOPM, HELPM, TEMPOM, CLEARM, QUITM };

int col, bpm;
char grid[16][8];
double tempo;
bool quit, isplaying;
SceUID soundloop;
OSL_SOUND *sound[8];
OSL_IMAGE *select;

void tmInit(void);
void tmDebug(int x, int y, const char *str);
void tmWait(float sec);
void *tmSoundloop(void *arg);
void tmMainloop(void);
void tmDrawgrid(void);
void tmHelp(void);
void setUpVirtualFileMenu(void);

int tmMenu(void);
void tmClear(void);
double tmTempo(int b);
int tmBPM(double t);

#endif
