/* ToneMatrix - menu.c
 * Copyright (c) 2011 Tanner Babcock */
#include <oslib/oslib.h>
#include "main.h" 
#define MAX 5

int tmMenu(void) {
	int menuoption = 0, x;
	char mstrings[MAX][40];
	while (!osl_quit) {
		oslStartDrawing();
		oslReadKeys();
		tmDrawgrid();
		oslDrawFillRect(0, 0, 480, 272, RGBA(0, 0, 0, 125));
		tempo = tmTempo(bpm);
		bpm = tmBPM(tempo);
		for (x = 0; x < MAX; x++) {
			bzero(mstrings[x], sizeof(mstrings[x]));
			switch (x) {
				case STOPM:
					sprintf(mstrings[x], "%s %s playing", (menuoption == x) ? "->" : "  ", (isplaying == TRUE) ? "Stop" : "Resume");
					break;
				case HELPM:
					sprintf(mstrings[x], "%s Help me", (menuoption == x) ? "->" : "  ");
					break;
				case TEMPOM:
					sprintf(mstrings[x], "%s Tempo: %d BPM", (menuoption == x) ? "->" : "  ", tmBPM(tempo));
					break;
				case CLEARM:
					sprintf(mstrings[x], "%s Clear grid", (menuoption == x) ? "->" : "  ");
					break;
				case QUITM:
					sprintf(mstrings[x], "%s Quit", (menuoption == x) ? "->" : "  ");
					break;
				// genius
			}
			oslDrawString(10, (60+(x*10)), mstrings[x]);
		}
		if ((osl_keys->pressed.up) && (menuoption > 0))
			menuoption--;
		if ((osl_keys->pressed.down) && (menuoption < (MAX-1)))
			menuoption++;
		if (osl_keys->pressed.left) {
			switch (menuoption) {
				case TEMPOM:
					if (bpm > 80)
						bpm -= 5;
					tempo = tmTempo(bpm);
					break;
			}
		}
		if (osl_keys->pressed.right) {
			switch (menuoption) {
				case TEMPOM:
					if (bpm < 200)
						bpm += 5;
					tempo = tmTempo(bpm);
					break;
			}
		}
		if (osl_keys->pressed.cross) {
			switch (menuoption) {
				case STOPM:
					return STOPM; break;
				case HELPM:
					return HELPM; break;
				case CLEARM:
					return CLEARM; break;
				case QUITM:
					return QUITM; break;
			}
		}
		if (osl_keys->pressed.start)
			break;
		oslEndDrawing();
		oslSyncFrame();
	}
	return 69;
}

void tmHelp(void) {
	oslClearScreen(RGBA(0, 0, 0, 255));
	while (!osl_quit) {
		oslStartDrawing();
		oslReadKeys();
		tmDrawgrid();
		oslDrawFillRect(0, 0, 480, 272, RGBA(0, 0, 0, 125));
		oslDrawString(5, 90, "ToneMatrix is a 16-step drum machine. The X axis represents");
		oslDrawString(5, 100, "one measure, and the Y axis represents eight different sounds.");
		oslDrawString(5, 110, "Select a node on the grid with the D-pad and the X button, and");
		oslDrawString(5, 120, "that sound will be played in time.");
		oslDrawString(5, 140, "Press O to stop/resume playing, and use /\\ (triangle) to clear");
		oslDrawString(5, 150, "the grid. Press START to use the menu, and use the D-pad to");
		oslDrawString(5, 160, "select a menu item or change a value (like the tempo), and X to");
		oslDrawString(5, 170, "confirm your choice.");
		oslDrawString(5, 190, "Press SELECT to hide this screen.");
		if (osl_keys->pressed.select)
			break;
		oslEndDrawing();
		oslSyncFrame();
	}
}
