/* ToneMatrix - misc.c
 * Copyright (c) 2011 Tanner Babcock */
#include <oslib/oslib.h>
#include <pspkernel.h>
#include <psputils.h>
#include <stdio.h>
#include <string.h>
#include "main.h"

void tmInit(void) {
	oslInit(0);
	oslInitGfx(OSL_PF_8888, 1);
	oslInitConsole();
	oslInitAudio();
	// tmDebug(10, 10, "Getting ready...");
	int x, y;
	char tmp[25];
	// tmDebug(10, 20, "Loading sounds...");
	for (x = 0; x < 8; x++) {
		bzero(tmp, sizeof(tmp));
		sprintf(tmp, "sounds/tone%d.wav", x);
		sound[x] = oslLoadSoundFile(tmp, OSL_FMT_NONE);
		if (!sound[x]) {
			bzero(tmp, sizeof(tmp));
			sprintf(tmp, "ERROR: sound file %d missing", x);
			tmDebug(10, 30, tmp);
			tmAbort(40);
		}
	}
	// setUpVirtualFileMenu();
	select = oslLoadImageFile("select.png", OSL_IN_RAM, OSL_PF_5551);
	oslSetBkColor(RGBA(0, 0, 0, 0));
	tmClear();
	quit = FALSE;
	col = 0;
	tempo = 125000;
	bpm = tmBPM(tempo);
	isplaying = TRUE;
	soundloop = sceKernelCreateThread("Sound Loop", tmSoundloop, 0x11, (256 * 1024), PSP_THREAD_ATTR_USER, NULL);
	oslClearScreen(RGBA(0, 0, 0, 255));
	return;
}

void tmDebug(int x, int y, const char *str) {
	int z;
	for (z = 0; z != 3; z++) {
		oslStartDrawing();
		oslDrawString(x, y, str);
		oslEndDrawing();
		oslSyncFrame();
	}
	return;
}

/* void setUpVirtualFileMenu(void) {
	OSL_VIRTUALFILENAME ram_files[] = {{"ram:/select.png", (void*)select_data, sizeof(select_data), &VF_MEMORY}};
	oslAddVirtualFileList(ram_files, oslNumberof(ram_files));
} */

void tmClear(void) {
	int y, z;
	for (y = 0; y < 16; y++) {
		for (z = 0; z < 8; z++)
			grid[y][z] = OFF;
	}
	grid[0][0] = CURSOFF;
	return;
}

double tmTempo(int b) {
	return (15000000 / b);
}

int tmBPM(double t) {
	return (15000000 / t);
}
